/* GDK - The GIMP Drawing Kit
 * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * Modified by the GTK+ Team and others 1997-2000.  See the AUTHORS
 * file for a list of people on the GTK+ Team.  See the ChangeLog
 * files for a list of changes.  These files are distributed with
 * GTK+ at ftp://ftp.gtk.org/pub/gtk/.
 */

#ifndef __GDK_DIRECTFB_H__
#define __GDK_DIRECTFB_H__

#include "gdk/gdkprivate.h"


typedef struct _GdkDirectFBDisplay GdkDirectFBDisplay;

extern GdkDirectFBDisplay *gdk_display;

#define GDK_ROOT_PARENT()             ((GdkWindow *) gdk_parent_root)
#define GDK_DISPLAY()                 gdk_display

extern const gchar *gdk_progclass;

#define gdk_window_foreign_new(xid) gdk_window_ref (xid)
#define gdk_window_lookup(xid)      ((GdkWindow *) (xid))
#define gdk_pixmap_lookup(xid)      ((GdkPixmap *) (xid))
#define gdk_font_lookup(xid)        ((GdkFont *) (xid))

extern GdkAtom gdk_selection_property;

#define GDK_DIRECTFB_USE_CHILD_SHAPE ((void *)1)


/* FB specific functions: */

typedef gboolean (* GdkWindowChildChanged) (GdkWindow *window,
                                            gint       x, 
                                            gint       y,
                                            gint       width, 
                                            gint       height,
                                            gpointer   user_data);
typedef void     (* GdkWindowChildGetPos)  (GdkWindow *window,
                                            gint      *x, 
                                            gint      *y,
                                            gpointer   user_data);

void gdk_fb_window_set_child_handler (GdkWindow              *window,
                                      GdkWindowChildChanged  changed,
                                      GdkWindowChildGetPos   get_pos,
                                      gpointer               user_data);


#endif /* __GDK_DIRECTFB_H__ */
