#include "gdkinput.h"
#include "gdkprivate.h"


static GdkDeviceAxis gdk_input_core_axes[] = 
  {
    { GDK_AXIS_X, 0, 0 },
    { GDK_AXIS_Y, 0, 0 }
  };

GdkDevice gdk_input_core_info =
  {
    "Core Pointer",
    GDK_SOURCE_MOUSE,
    GDK_MODE_SCREEN,
    TRUE,
    
    2,
    gdk_input_core_axes,
    
    0,
    NULL
  };


/* Global variables  */

GdkDevice * gdk_core_pointer = (GdkDevice *) &gdk_input_core_info;
gboolean    gdk_input_ignore_core;
GList     * gdk_input_devices;
GList     * gdk_input_windows;


GList *
gdk_devices_list (void)
{
  return gdk_input_devices;
}

void
gdk_input_exit (void)
{
}

gboolean
gdk_device_get_axis (GdkDevice  *device, 
                     gdouble    *axes, 
                     GdkAxisUse  use, 
                     gdouble    *value)
{
  g_return_val_if_fail (device != NULL, FALSE);

  if (axes == NULL)
    return FALSE;

  g_message ("unimplemented %s", __FUNCTION__);

  return FALSE;
}

void
gdk_device_set_key (GdkDevice       *device,
                    guint            index,
                    guint            keyval,
                    GdkModifierType  modifiers)
{
  g_return_if_fail (device != NULL);
  g_return_if_fail (index < device->num_keys);

  device->keys[index].keyval    = keyval;
  device->keys[index].modifiers = modifiers;
}

void
gdk_device_set_axis_use (GdkDevice   *device,
                         guint        index,
                         GdkAxisUse   use)
{
  g_return_if_fail (device != NULL);
  g_return_if_fail (index < device->num_axes);

  device->axes[index].use = use;

  switch (use)
    {
    case GDK_AXIS_X:
    case GDK_AXIS_Y:
      device->axes[index].min = 0.;
      device->axes[index].max = 0.;
      break;
    case GDK_AXIS_XTILT:
    case GDK_AXIS_YTILT:
      device->axes[index].min = -1.;
      device->axes[index].max = 1;
      break;
    default:
      device->axes[index].min = 0.;
      device->axes[index].max = 1;
      break;
    }
}

void 
gdk_device_free_history (GdkTimeCoord **events,
                         gint           n_events)
{
  gint i;
  
  for (i = 0; i < n_events; i++)
    g_free (events[i]);

  g_free (events);
}

gboolean
gdk_device_set_mode (GdkDevice    *device,
                     GdkInputMode  mode)
{
  g_message ("unimplemented %s", __FUNCTION__);

  return FALSE;
}

void
gdk_input_set_extension_events (GdkWindow        *window, 
                                gint              mask,
                                GdkExtensionMode  mode)
{
  g_message ("unimplemented %s", __FUNCTION__);
}

